package com.haulmont.vaadin.sample

import com.vaadin.server.VaadinRequest
import com.vaadin.ui.*

public class SampleVaadinUI extends UI {
    int n = 10
    int c = 10
    int r = 10

    VerticalLayout layout
    TextField text1
    TextField text2
    TextField text3

    @Override
    protected void init(VaadinRequest request) {
        initMain()
    }

    protected void initMain() {
        layout = new VerticalLayout()
        layout.setStyleName("main")
        layout.setSpacing(true)
        layout.setSizeFull()
        setContent(layout)


        def hbox = new HorizontalLayout()
        hbox.setSpacing(true)
        layout.addComponent(hbox)

        text1 = new TextField()
        text1.setCaption("vbox count")
        text1.setRequired(true)
        text1.setValue(n + "")
        hbox.addComponent(text1)

        text2 = new TextField()
        text2.setCaption("rows count * 6")
        text2.setRequired(true)
        text2.setValue(r + "")
        hbox.addComponent(text2)

        text3 = new TextField()
        text3.setCaption("columns count * 3")
        text3.setRequired(true)
        text3.setValue(c + "")
        hbox.addComponent(text3)

        def btn = new Button("repaint")
        btn.addClickListener(new Button.ClickListener() {
            void buttonClick(Button.ClickEvent clickEvent) {
                repaint()
            }
        })
        hbox.addComponent(btn)
    }

    protected def repaint() {
        try {
            n = Integer.parseInt(text1.getValue())
        } catch (NumberFormatException e) {
            n = 10
        }

        try {
            r = Integer.parseInt(text2.getValue())
        } catch (NumberFormatException e) {
            r = 10
        }

        try {
            c = Integer.parseInt(text3.getValue())
        } catch (NumberFormatException e) {
            c = 10
        }
        initMain()

        def prevL = layout
        n.times {
            def curL = new VerticalLayout()
            curL.setSpacing(true)
            curL.setSizeFull()
            prevL.addComponent(curL)
            prevL.setExpandRatio(curL, 1)
            prevL = curL
        }


        def table = createTable()
        prevL.addComponent(table)
        prevL.setExpandRatio(table, 1)
    }

    protected def createTable() {
        Table table = new Table("This is my Table in " + n + " VerticalBox");
        table.setWidth("100%")

        /* Define the names and data types of columns.
         * The "default value" parameter is meaningless here. */

        c.times {
            table.addContainerProperty("First Name" + it, String.class, null);
            table.addContainerProperty("Last Name" + it, String.class, null);
            table.addContainerProperty("Year" + it, Integer.class, null);
        }

        /* Add a few items in the table. */
        int i = 0
        r.times {

            table.addItem([
                    "Nicolaus" + it, "Copernicus", new Integer(1473)
            ] * this.c as Object[]
                    , new Integer(i++));
            table.addItem([
                    "Tycho" + it, "Brahe", new Integer(1546)
            ] * this.c as Object[]
                    , new Integer(i++));
            table.addItem([
                    "Giordano" + it, "Bruno", new Integer(1548)
            ] * this.c as Object[], new Integer(i++));
            table.addItem([
                    "Galileo" + it, "Galilei", new Integer(1564)
            ] * this.c as Object[], new Integer(i++));
            table.addItem([
                    "Johannes" + it, "Kepler", new Integer(1571)
            ] * this.c as Object[], new Integer(i++));
            table.addItem([
                    "Isaac" + it, "Newton", new Integer(1643)
            ] * this.c as Object[], new Integer(i++))

        };

        return table;
    }
}